/*
 * Copyright (c) 2006-2011 Christian Plattner. All rights reserved.
 * Please refer to the LICENSE.txt for licensing details.
 */

package ch.ethz.ssh2.log;

import android.util.Log;

public class Logger {
    private static final String TAG = "ConnectBot.ssh";
    public static boolean enabled = false;

    public static Logger getLogger(Class<?> x) {
        return new Logger();
    }

    public Logger() {
    }

    public final boolean isEnabled() {
        return enabled;
    }

    public boolean isDebugEnabled() {
        return enabled;
    }

    public void debug(String message) {
        if (enabled) Log.d(TAG, message);
    }

    public boolean isInfoEnabled() {
        return enabled;
    }

    public void info(String message) {
        if (enabled) Log.i(TAG, message);
    }

    public boolean isWarningEnabled() {
        return enabled;
    }

    public void warning(String message) {
        if (enabled) Log.w(TAG, message);
    }
}